// LIBTYPEDEF.H : some typedefs + other settings here...

// Copyright (C) 1998 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

/*################################################################################################*/

#ifndef LIBTYPEDEF_H
#define LIBTYPEDEF_H

//#include "libghemicalconfig2.h"

#include <math.h>

/*################################################################################################*/

// added by Robert Williams for Compaq cxx, alpha 11/28/01

#define __USE_STD_IOSTREAM

// the value for M_PI is needed for Win32 platform...

#ifdef WIN32
#define M_PI 3.141592654
#endif	// WIN32

class engine;	// engine.h ; this is for ValueFunction().

#include <iostream>
using namespace std;

/*################################################################################################*/

typedef int i32s;
typedef unsigned int i32u;

typedef double f64;

/*################################################################################################*/

#ifdef HAVE_GL_GLUT_H

#ifdef WIN32
#include <windows.h>	// need to have this before the GL stuff...
#endif	// WIN32

#include <GL/glut.h>

typedef GLint iGLs;
typedef GLuint iGLu;

typedef GLfloat fGL;
typedef GLfloat * ref_fGL;

#else

typedef int iGLs;
typedef unsigned int iGLu;

typedef float fGL;
typedef float * ref_fGL;

#endif

/*################################################################################################*/

typedef fGL ValueFunction(engine *, fGL *, fGL *);
typedef void ColorFunction(fGL, fGL, fGL *);

/*################################################################################################*/

#endif	// LIBTYPEDEF_H

// eof
